﻿
Option Strict On

' #########
' Fassung vom 11.12.23
' #########

Imports System
Imports System.Data
Imports System.IO
Imports System.Windows.Forms
' Imports System.Windows.Forms.DataVisualization.Charting



Public Class Form1
    Public OberGrenze As Integer
    Public TageDifferenz(99) As Integer
    Public i As Integer
    Private Property Anzeigetabelle As Object
    Private Property Exception As Object
    Public Wasserverbrauch(99) As Single
    Public Gasverbrauch(99) As Single
    Public Stromverbrauch(99) As Single
    Public StromOutput(99) As Single
    Public Dataset1 As New DataSet




    Private Sub BtnEnd_Click(sender As Object, e As EventArgs) Handles BtnEnd.Click
        End
    End Sub

    Private Sub BtnRead_Click(sender As Object, e As EventArgs) Handles BtnRead.Click
        Dim EingabemaskeBindingSource As New BindingSource()
        EingabemaskeBindingSource.DataSource = Dataset1.Tables("Eingabemaske")
        DataGridView1.DataSource = EingabemaskeBindingSource

        Try
            ' entferne zuvor alle Daten aus allen Tabellen des Dataset
            Dataset1.Clear()
            ' lese die gespeicherten Daten neu in das DGV ein:
            Dataset1.ReadXml("Eingabemaske")
        Catch ex As Exception
            MsgBox("Kann Datei nicht finden, möglicherweise existiert das File nicht")
        End Try

    End Sub

    Private Sub BtnWrite_Click(sender As Object, e As EventArgs) Handles BtnWrite.Click
        Dataset1.WriteXml("Eingabemaske")
    End Sub

    Private Sub BtnAuswertung_Click(sender As Object, e As EventArgs) Handles BtnAuswertung.Click
        Dim dataset1 As New DataSet
        Dim Datatable1 As New DataTable("Eingabemaske")

        ' Feld erstellen
        Dim Datums(99) As Date  ' Datums = Feld zur Berechnung der Differenztage

        Dim i As Integer
        ' Dim Zeile() As DataRow
        If Not File.Exists("Eingabemaske") Then
            MsgBox("File scheint nicht zu existieren")
        End If
        Dataset1.Clear()
        Dataset1.ReadXml("Eingabemaske")

        If Datatable1.Rows.Count = Nothing Then Stop
        If Datatable1.Rows.Count = 0 Then Stop
        If Datatable1.Rows.Count > 99 Then
            MsgBox(" Achtung: Tabelle ist gefüllt, weitere Dateneingabe nicht möglich !")
        End If
        OberGrenze = Datatable1.Rows.Count

        ' Erstellen des zweiten DGV, in welchem Werte angezeigt werden

        Dim DataGridView1 As New DataGridView
        With DataGridView1
            .Columns.Add("Differenztage", "Zahl der Tage")     ' Spalte 0 #####
            .Columns.Add("Wasser", "Wasserverbrauch pro Tag")  ' Spalte 1 ##### 
            .Columns.Add("Gas", "Gasverbrauch pro Tag")        ' Spalte 2 #####
            .Columns.Add("Strom in", "Stromverbrauch pro Tag") ' Spalte 3 #####
            .Columns.Add("Strom out", "Stromproduktion")       ' Spalte 4 #####
            .Dock = DockStyle.Fill
            .Left = 600
            .Top = 600
            .Width = 600
            .DefaultCellStyle.Alignment = DataGridViewContentAlignment.MiddleRight

            ' hier können noch weitere Qualifikationen eingesetzt werden ##########
        End With
        For j As Integer = 1 To 99
            DataGridView1.Rows().Add()
        Next
        Me.Controls.Add(DataGridView1)


        For i = 0 To (OberGrenze - 2)   ' ############### ??  -  ist 2 richtig ??? ######################

            If IsNothing(Datatable1.Rows) Then Stop
            If IsNothing(Datatable1.Rows(i)) Then Stop

            If Datatable1.Rows(1).IsNull(1) Then Stop
            If Datatable1.Rows(i + 1).IsNull(1) Then Stop

            Dim DatumA As Date = CDate(Datatable1.Rows(i)(1))
            Dim DatumB As Date = CDate(Datatable1.Rows(i + 1)(1))

            ' Errechnete Werte einfügen
            Datums(i) = DatumA
            If i < (Datatable1.Rows.Count - 1) Then
                Datums(i + 1) = DatumB
            End If

            ' Versuchen, die NullException abzuwehren

            If i >= 0 Then
                If Not i > (OberGrenze - 1) Then
                    Try
                        ' Differenztage berechnen
                        Dim daysDifference As Integer = (Datums(i + 1) - Datums(i)).Days
                        TageDifferenz(i) = daysDifference
                        DataGridView1.Rows(i).Cells(0).Value = TageDifferenz(i)
                    Catch ex As Exception
                    End Try
                End If
            End If
            '
            ' #########  Abteilung Wasserverbrauch
            '
            Wasserverbrauch(i) = CSng(Datatable1.Rows(i)(2))
            Wasserverbrauch(i + 1) = CSng(Datatable1.Rows(i + 1)(2))
            Wasserverbrauch(i + 2) = (Wasserverbrauch(i + 1) - Wasserverbrauch(i)) / TageDifferenz(i)
            Dim VerbrauchFormatiert As String = String.Format("{0:0.00}", Wasserverbrauch(i + 2))
            DataGridView1.Rows(i).Cells(1).Value = VerbrauchFormatiert

            '
            ' #########  Abteilung Gasverbrauch
            '

            Gasverbrauch(i) = CSng(Datatable1.Rows(i)(3))
            Gasverbrauch(i + 1) = CSng(Datatable1.Rows(i + 1)(3))
            Gasverbrauch(i + 2) = (Gasverbrauch(i + 1) - Gasverbrauch(i)) / TageDifferenz(i)
            VerbrauchFormatiert = String.Format("{0:0.000}", Gasverbrauch(i + 2))
            DataGridView1.Rows(i).Cells(2).Value = VerbrauchFormatiert

            '
            ' #########  Abteilung Stromverbrauch
            '

            Stromverbrauch(i) = CSng(Datatable1.Rows(i)(4))
            Stromverbrauch(i + 1) = CSng(Datatable1.Rows(i + 1)(4))
            Stromverbrauch(i + 2) = (Stromverbrauch(i + 1) - Stromverbrauch(i)) / TageDifferenz(i)
            VerbrauchFormatiert = String.Format("{0:0.00}", Stromverbrauch(i + 2))
            DataGridView1.Rows(i).Cells(3).Value = VerbrauchFormatiert
            '
            ' #########  Abteilung Stromproduktion ("out")
            '

            StromOutput(i) = CSng(Datatable1.Rows(i)(5))
            StromOutput(i + 1) = CSng(Datatable1.Rows(i + 1)(5))
            StromOutput(i + 2) = (StromOutput(i + 1) - StromOutput(i)) / TageDifferenz(i)
            VerbrauchFormatiert = String.Format("{0:0.00}", StromOutput(i + 2))
            DataGridView1.Rows(i).Cells(4).Value = VerbrauchFormatiert

        Next   ' ################################################################




    End Sub

    Private Sub BtnZeichne_Click(sender As Object, e As EventArgs) Handles BtnZeichne.Click

    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load

    End Sub


    Private Sub EingabemaskeBindingSource_CurrentChanged(sender As Object, e As EventArgs) Handles EingabemaskeBindingSource.CurrentChanged

    End Sub
End Class
